"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PrivateRoute = void 0;
var react_1 = __importDefault(require("react"));
var react_auth_shared_1 = require("@brightlayer-ui/react-auth-shared");
var react_router_dom_1 = require("react-router-dom");
/**
 * Component that renders a conditional Route. If the user is not authenticated, this route
 * will redirect to the login route. If the user is authenticated, it will render the provided
 * content.
 *
 * @param authRoute The route to redirect to when the user is not authenticated
 *
 * @category Component
 */
var PrivateRoute = function (props) {
    var children = props.children, other = __rest(props, ["children"]);
    var securityState = react_auth_shared_1.useSecurityState();
    var location = react_router_dom_1.useLocation();
    if (!securityState.isAuthenticatedUser) {
        return (react_1.default.createElement(react_router_dom_1.Route, __assign({}, other),
            react_1.default.createElement(react_router_dom_1.Redirect, { to: { pathname: props.authRoute, state: { from: location } } })));
    }
    return react_1.default.createElement(react_router_dom_1.Route, __assign({}, other), children);
};
exports.PrivateRoute = PrivateRoute;
