"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SimpleDialog = void 0;
var react_1 = __importDefault(require("react"));
var Button_1 = __importDefault(require("@material-ui/core/Button"));
var Dialog_1 = __importDefault(require("@material-ui/core/Dialog"));
var Typography_1 = __importDefault(require("@material-ui/core/Typography"));
var DialogTitle_1 = __importDefault(require("@material-ui/core/DialogTitle"));
var DialogContent_1 = __importDefault(require("@material-ui/core/DialogContent"));
var DialogActions_1 = __importDefault(require("@material-ui/core/DialogActions"));
var react_auth_shared_1 = require("@brightlayer-ui/react-auth-shared");
var styles_1 = require("../styles");
/**
 * Component that renders a simple dialog with a title, body description, and a close button.
 *
 * @param title text to show in the title
 * @param body text to show in the body
 * @param onClose function to call when the close button is clicked
 * @param props all other props will be spread to the underlying Dialog component
 *
 * @category Component
 */
var SimpleDialog = function (props) {
    var title = props.title, body = props.body, dialogProps = __rest(props, ["title", "body"]);
    var classes = styles_1.useDialogStyles();
    var t = react_auth_shared_1.useLanguageLocale().t;
    return (react_1.default.createElement(Dialog_1.default, __assign({ disableBackdropClick: true }, dialogProps),
        react_1.default.createElement(DialogTitle_1.default, { className: classes.dialogTitle }, title),
        react_1.default.createElement(DialogContent_1.default, { className: classes.dialogContent, style: { flex: '1 1 auto' } },
            react_1.default.createElement(Typography_1.default, null, body)),
        react_1.default.createElement(DialogActions_1.default, { className: classes.dialogActions },
            react_1.default.createElement(Button_1.default, { variant: "text", color: "primary", onClick: dialogProps.onClose, className: classes.dialogButton }, t('blui:ACTIONS.OKAY').toUpperCase()))));
};
exports.SimpleDialog = SimpleDialog;
