"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ForgotPassword = void 0;
var react_1 = __importStar(require("react"));
var react_auth_shared_1 = require("@brightlayer-ui/react-auth-shared");
var react_i18next_1 = require("react-i18next");
var react_router_dom_1 = require("react-router-dom");
var components_1 = require("../components");
var Button_1 = __importDefault(require("@material-ui/core/Button"));
var CardActions_1 = __importDefault(require("@material-ui/core/CardActions"));
var CardContent_1 = __importDefault(require("@material-ui/core/CardContent"));
var CardHeader_1 = __importDefault(require("@material-ui/core/CardHeader"));
var Divider_1 = __importDefault(require("@material-ui/core/Divider"));
var Typography_1 = __importDefault(require("@material-ui/core/Typography"));
var Grid_1 = __importDefault(require("@material-ui/core/Grid"));
var TextField_1 = __importDefault(require("@material-ui/core/TextField"));
var createStyles_1 = __importDefault(require("@material-ui/core/styles/createStyles"));
var makeStyles_1 = __importDefault(require("@material-ui/core/styles/makeStyles"));
var useTheme_1 = __importDefault(require("@material-ui/core/styles/useTheme"));
var CheckCircle_1 = __importDefault(require("@material-ui/icons/CheckCircle"));
var styles_1 = require("../styles");
var clsx_1 = __importDefault(require("clsx"));
var useStyles = makeStyles_1.default(function (theme) {
    return createStyles_1.default({
        link: {
            fontWeight: 600,
            color: theme.palette.primary.main,
            textTransform: 'none',
            textDecoration: 'none',
            '&:visited': {
                color: theme.palette.primary.main,
            },
        },
    });
});
/**
 * Renders the screen for Forgot Password where a user enters their
 * email to receive a reset link.
 *
 * @category Component
 */
var ForgotPassword = function () {
    var _a;
    var t = react_auth_shared_1.useLanguageLocale().t;
    var history = react_router_dom_1.useHistory();
    var classes = useStyles();
    var sharedClasses = styles_1.useDialogStyles();
    var theme = useTheme_1.default();
    var accountUIState = react_auth_shared_1.useAccountUIState();
    var accountUIActions = react_auth_shared_1.useAccountUIActions();
    var contactPhone = react_auth_shared_1.useInjectedUIContext().contactPhone;
    // Local state
    var _b = react_1.default.useState(''), emailInput = _b[0], setEmailInput = _b[1];
    var _c = react_1.default.useState(false), hasAcknowledgedError = _c[0], setHasAcknowledgedError = _c[1];
    // Network state (forgotPassword)
    var forgotPasswordTransit = accountUIState.forgotPassword;
    var isInTransit = forgotPasswordTransit.transitInProgress;
    var hasTransitError = forgotPasswordTransit.transitErrorMessage !== null;
    var transitErrorMessage = forgotPasswordTransit.transitErrorMessage;
    var finished = accountUIState.forgotPassword.transitSuccess;
    var resetPassword = react_1.useCallback(function (email) {
        setHasAcknowledgedError(false);
        void accountUIActions.actions.forgotPassword(email);
    }, [setHasAcknowledgedError, accountUIActions]);
    var canContinue = react_1.useCallback(function () { return react_auth_shared_1.EMAIL_REGEX.test(emailInput) && !accountUIState.forgotPassword.transitInProgress; }, [emailInput, accountUIState]);
    var onContinue = react_1.useCallback(function () {
        if (accountUIState.forgotPassword.transitSuccess) {
            history.goBack();
        }
        else {
            resetPassword(emailInput);
        }
    }, [accountUIState, resetPassword, history, emailInput]);
    // Reset state on dismissal
    react_1.useEffect(function () { return function () {
        accountUIActions.dispatch(react_auth_shared_1.AccountActions.resetPasswordReset());
    }; }, // eslint-disable-next-line react-hooks/exhaustive-deps
    []);
    // Dynamic Elements
    var errorDialog = (react_1.default.createElement(components_1.SimpleDialog, { title: t('blui:MESSAGES.ERROR'), body: t(transitErrorMessage !== null && transitErrorMessage !== void 0 ? transitErrorMessage : ''), open: hasTransitError && !hasAcknowledgedError, onClose: function () {
            setHasAcknowledgedError(true);
        } }));
    var body;
    if (accountUIState.forgotPassword.transitSuccess) {
        body = (react_1.default.createElement(components_1.FinishState, { icon: react_1.default.createElement(CheckCircle_1.default, { color: 'primary', style: { fontSize: 100, marginBottom: theme.spacing(2) } }), title: t('blui:MESSAGES.EMAIL_SENT'), description: react_1.default.createElement(react_i18next_1.Trans, { i18nKey: 'blui:FORGOT_PASSWORD.LINK_SENT_ALT', values: { email: emailInput } },
                "Link has been sent to ",
                react_1.default.createElement("b", null, emailInput),
                ".") }));
    }
    else {
        body = (react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement(Typography_1.default, null,
                react_1.default.createElement(react_i18next_1.Trans, { i18nKey: 'blui:FORGOT_PASSWORD.INSTRUCTIONS_ALT', values: { phone: contactPhone } },
                    "Please enter your email, we will respond in ",
                    react_1.default.createElement("b", null, "one business day"),
                    ". For urgent issues please call",
                    ' ',
                    react_1.default.createElement("a", { href: "tel:" + contactPhone, className: classes.link }, contactPhone),
                    ".")),
            react_1.default.createElement(Divider_1.default, { className: sharedClasses.fullDivider }),
            react_1.default.createElement(TextField_1.default, { id: "email", label: t('blui:LABELS.EMAIL'), fullWidth: true, value: emailInput, onChange: function (evt) { return setEmailInput(evt.target.value); }, onKeyPress: function (e) {
                    if (e.key === 'Enter' && canContinue())
                        onContinue();
                }, variant: "filled", error: hasTransitError, helperText: hasTransitError ? t('blui:FORGOT_PASSWORD.ERROR') : '' })));
    }
    return (react_1.default.createElement(components_1.BrandedCardContainer, { loading: isInTransit },
        errorDialog,
        react_1.default.createElement(CardHeader_1.default, { title: react_1.default.createElement(Typography_1.default, { variant: 'h6', style: { fontWeight: 600 } }, t('blui:HEADER.FORGOT_PASSWORD')), className: sharedClasses.dialogTitle }),
        react_1.default.createElement(CardContent_1.default, { className: sharedClasses.dialogContent }, body),
        react_1.default.createElement(Divider_1.default, null),
        react_1.default.createElement(CardActions_1.default, { className: sharedClasses.dialogActions },
            react_1.default.createElement(Grid_1.default, { container: true, direction: "row", alignItems: "center", justify: "space-between", style: { width: '100%' } },
                !finished && (react_1.default.createElement(Button_1.default, { variant: "outlined", color: "primary", onClick: function () { return history.goBack(); }, className: sharedClasses.dialogButton }, t('blui:ACTIONS.BACK'))),
                react_1.default.createElement(Button_1.default, { variant: "contained", disableElevation: true, disabled: !canContinue(), color: "primary", onClick: onContinue, className: clsx_1.default(sharedClasses.dialogButton, (_a = {}, _a[sharedClasses.fullWidth] = finished, _a)) }, accountUIState.forgotPassword.transitSuccess ? t('blui:ACTIONS.DONE') : t('blui:ACTIONS.OKAY'))))));
};
exports.ForgotPassword = ForgotPassword;
